/////////////////////////////////////////////////////////
//
// My Picture Viewer - hopefully to include a browser
//
// K. Slack 27/9/99
////////////////////////////////////////////////////////

#include "picview.h"
#include <Window.h>
#include <View.h>
#include <Button.h>
#include <stdio.h>
#include <string.h>
#include <Path.h>
#include <Entry.h>
#include <Directory.h>
#include <TranslationUtils.h>


int main()
{

	picview		myApplication;

	myApplication.Run();
	return (0);

}


picview::picview() :
			BApplication("application/x-vnd.Electrotech-picview")
{
	BRect		pic_Rect(50, 50, 400, 150);
	BRect		pic_Button_Rect(0, 0, 100, 20);
	BRect		see_Button_Rect(0, 24, 100, 63);
	BRect		die_Button_Rect(0, 48, 100, 41);
	BRect		cwd_Button_Rect(100, 3, 200, 100);
	BRect		info_view_Rect(100, 30, 200, 175);
	BPath		cwd_path(".");

	thumb_Rect.Set(0, 0, 100, 100);
	thumb_Window = NULL;
	
	click_cnt = 0;
	sprintf(click_msg[0], "Again");
	sprintf(click_msg[1], "Clicked");
	cnt_imgs = 0;
	old_cnt = 0;

	sprintf(cwd_string, "Dir: %s", cwd_path.Path());
	sprintf(info_string, "Welcome");

	cur_dir = new BStringView(cwd_Button_Rect, "cwd_info", cwd_string, B_FOLLOW_NONE, B_WILL_DRAW);
	info_view = new BStringView(info_view_Rect, "info_view", info_string, B_FOLLOW_NONE, B_WILL_DRAW);

	info_view->SetFontSize(32);
	cur_dir->SetFontSize(12);

	browse_sel = false;

	browse_panel = new BFilePanel(B_OPEN_PANEL, NULL, NULL, B_DIRECTORY_NODE, false, new BMessage('SELE'), NULL, false, true);
	browse_panel->Hide();

	pic_Window = new BWindow(pic_Rect, "Pic_Viewer_Window", B_TITLED_WINDOW, B_WILL_DRAW | B_NOT_RESIZABLE | B_WILL_ACCEPT_FIRST_CLICK, B_CURRENT_WORKSPACE);

	pic_Button = new BButton(pic_Button_Rect, "Browse", "Browse", new BMessage('BROW'));
	see_Button = new BButton(see_Button_Rect, "View", "View", new BMessage('VIEW'));
	die_Button = new BButton(die_Button_Rect, "Quit", "Quit", new BMessage('DIEN'));

	// Will have to create a file panel to select browse directory
	pic_Window->AddChild(pic_Button);
	pic_Window->AddChild(see_Button);
	pic_Window->AddChild(die_Button);
	pic_Window->AddChild(cur_dir);
	pic_Window->AddChild(info_view);
	pic_Button->SetTarget(be_app);
	pic_Button->ResizeToPreferred();
	die_Button->ResizeToPreferred();
	see_Button->ResizeToPreferred();
	cur_dir->ResizeToPreferred();
	info_view->ResizeToPreferred();
	die_Button->SetTarget(be_app);
	see_Button->SetTarget(be_app);

	browse_panel->SetButtonLabel(B_DEFAULT_BUTTON, "Browse Here");
	browse_panel->SetButtonLabel(B_CANCEL_BUTTON, "No More");
	browse_panel->Window()->SetTitle("Select a Directory to Browse");

	pic_Window->Show();

}


void picview::MessageReceived(BMessage* message)
{

	uint32	file_cnt;
	uint32 	index = 0;
	BEntry	direntry;
	BPath	dirpath;
	char	cntr[10];

	switch(message->what)
	{
		case 'BROW':
			if (pic_Window->Lock()) {
				browse_panel->Show();
				pic_Window->Unlock();
			}
			break;
		case 'SELE':

			if (pic_Window->Lock()) {
				// display a please wait msg in the main window
				sprintf(info_string, "Please Wait...");
				info_view->SetText(info_string);
				info_view->ResizeToPreferred();
				pic_Window->Unlock();
			}

			printf("\nselect noticed\n");
			if (thumb_Window != NULL) {

				if (thumb_Window->Lock()) {
					printf("\ninside loop\n");
					int32 ch_cnt = thumb_Window->CountChildren();

					for (int32 c = 0; c < ch_cnt ; c++) {

						int32 testcnt = thumb_Window->CountChildren();
						if (testcnt > 0) {
							printf("\nchildren keft = %ld\n", testcnt);
						}
						ImagingView *view = (ImagingView *)thumb_Window->ChildAt(0);
						printf("\ncurrent_child = %ld", c);

						if (view != NULL) {
							printf("\nkilling view %ld\n", c);
							view->KillViews();
							view->RemoveSelf();
							delete view;
							printf("\nkilled view %ld\n", c);
						}
						else {
							continue;
						}


					} // end for loop

					if (thumb_Window->CountChildren() > 0) {
						printf("\nstill has children - %ld\n", thumb_Window->CountChildren());
					}
					thumb_Window->Unlock();

					BMessage 	mymsg;
					mymsg.what = B_QUIT_REQUESTED;
					thumb_Window->PostMessage(&mymsg);
					thumb_Window = NULL;
				}


			} // end check for non-null thumb_Window pointer

			cnt_imgs = 0;
			// Get ref from message
			message->FindRef("refs", 0, &refs);
			picdir.SetTo(&refs);
			direntry.SetTo(&refs);

			// Get number of files
			printf("\nNumber of Files = %ld\n", picdir.CountEntries());

			file_cnt = picdir.CountEntries();
			direntry.GetPath(&dirpath);
			printf("\ndirectory = %s\n", dirpath.Path());

			// change label name
			// grab window attention
			if (pic_Window->Lock()) {
				sprintf(cwd_string, "Dir: %s", dirpath.Path());
				cur_dir->SetText(cwd_string);
				cur_dir->ResizeToPreferred();
				pic_Window->Unlock();
			}

			printf("\nafter window change\told_cnt = %ld\n", old_cnt);

			thumb_Rect.left = 0;
			thumb_Rect.top = 0;
			printf("\nafter resetting thumb_Rect vals");
			thumb_Rect.right = 100;
			thumb_Rect.bottom = 100;


			thumb_Window = new BWindow(BRect(50, 50, 350, 650), "thumb_Window", B_TITLED_WINDOW, B_WILL_DRAW | B_NOT_CLOSABLE | B_WILL_ACCEPT_FIRST_CLICK, B_CURRENT_WORKSPACE);
			thumb_Window->MoveBy(300, 0);

			// Step through directory looking for images
			for (index = 0; index < file_cnt; index++) {


				picdir.GetNextEntry(&entry, true);
				entry.GetPath(&path);
				printf("\nfilename = %s\n", path.Path());

				if (path.Path() == NULL) {
					printf("\nnull file - skip\n");
				}
				else {
					// Make the bitmap from the file
					testbmp = BTranslationUtils::GetBitmapFile(path.Path(), NULL);
					if (testbmp == NULL) {
						printf("\nbitmap invalid - quitting\n");
					}
					else if (testbmp->IsValid() != true) {
						printf("\nbitmap invalid\n");
						be_app->Quit();
					}
					else {
						// another image to display - hopefully sucessfully
						printf("\ncreating another image\n");
						cnt_imgs += 1;
						sprintf(cntr, "img%ld", cnt_imgs);
						thumb_view = new ImagingView(thumb_Rect, cntr, B_FOLLOW_LEFT | B_FOLLOW_TOP , B_WILL_DRAW | B_NAVIGABLE, testbmp, entry, true);

						// Create the view
						if (thumb_Window->Lock()) {
							thumb_Window->AddChild(thumb_view);
							delete testbmp;
							thumb_Window->Unlock();
						}

						thumb_Rect.left += 101;
						if (thumb_Rect.left > 300) {
							thumb_Rect.left = 0;
						}	

						thumb_Rect.right += 101;
						if (thumb_Rect.right > 400) {
							thumb_Rect.right = 100;
						}	

						if (thumb_Rect.left == 0) {
							thumb_Rect.top += 101;
							thumb_Rect.bottom += 101;
						}
					}				
				}
			}
			if (cnt_imgs > 0) {
				thumb_Window->Show();
			}
			else {
				// no images to display - remove
				thumb_Window->Quit();
			}
			if (pic_Window->Lock()) {
				// display a please wait msg in the main window
				sprintf(info_string, "Ready");
				info_view->SetText(info_string);
				info_view->ResizeToPreferred();
				pic_Window->Unlock();
			}

			old_cnt = cnt_imgs;

			break;
		case 'DIEN':
			// want to die gracefully - clean up stuff
			be_app->Quit();
			break;
		case 'ENTR':
				char *msgstr;
				msgstr = message->FindString("img_path");
				strcpy(&filenm[0], msgstr);
				printf("\nview file from message = %s", filenm);
				view_entry.SetTo(&filenm[0], true);
				browse_sel = true;
			break;
		case 'VIEW':
		
			// want to spawn new window
			if (browse_sel == true) {
				browse_sel = false;

				view_entry.GetPath(&view_path);
				printf("\nview_filename = %s\n", view_path.Path());

				// Make the bitmap from the file
				testbmp = BTranslationUtils::GetBitmapFile(view_path.Path(), NULL);
				if (testbmp->IsValid() != true) {
					printf("\nviewing -> bitmap invalid\n");
					be_app->Quit();
				}

				myview = new ImagingView(testbmp->Bounds(), filenm, B_FOLLOW_ALL_SIDES , B_FRAME_EVENTS | B_WILL_DRAW | B_WILL_ACCEPT_FIRST_CLICK, testbmp, view_entry, false);
				mywindow = new ImageWindow(myview->Frame(), filenm, B_FLOATING_WINDOW, B_WILL_DRAW, B_CURRENT_WORKSPACE, myview);
				mywindow->MoveBy(100, 100);

				// Create the view
				if (mywindow->Lock()) {
					mywindow->AddChild(myview);
					testbmp->~BBitmap();
					delete testbmp;
					mywindow->Unlock();
				}
				mywindow->Show();

			}
			break;

		default:
			// Pass up hierarchy
			BHandler::MessageReceived(message);
	}
}

void picview::RefsReceived(BMessage *message)
{

	// create BEntries or BFiles with the refs field in the msg
	// then do some other stuff (cause another msg into be_app
	// to create a VIEW with the file translated into a bitmap
	// but first check that the file is an image file - otherwise
	// create an alert box - by passing another msg - not an img
	// message->what = 'VIEW';
}
