#include <Application.h>
#include <View.h>
#include <Window.h>
#include <FilePanel.h>
#include <Bitmap.h>
#include <StringView.h>
#include <Box.h>
#include <Path.h>

class ImagingView : public BView
{
public:
	ImagingView(BRect frame, const char *name, uint32 resizingMode, uint32 flags, BBitmap *imgbmp, BEntry entry, bool thumb);
	ImagingView		*PreviousSibling(void);
	bool			KillViews(void);
	virtual	void	Draw(BRect updateRect);
	virtual void	AttachedToWindow();
	virtual void	MouseDown(BPoint point);
	virtual void	FrameResized(float width, float height);
	
protected:
	BBitmap *fOffscreenImage;
	BView	*fOffscreenView;
	BBitmap	*fSourceImage;
	bool	first_draw;
	bool	thumbnail;
	BEntry	img_entry;

private:

};


class ImageWindow : public BWindow
{
public:
	ImageWindow(BRect frame, const char *title, window_type type, uint32 flags, uint32 workspaces, ImagingView *aview);
	virtual void Quit(void);
protected:
	ImagingView *view;
};

